<template>
  <div id="class_index_wrapper" class="bt-container">
    <h2 class="page-title">조회하기 > 세션은행</h2>
    <div id="choiceLists">
      <el-form>
        <el-select placeholder="대학선택" v-model="chosen" @change="categoryChange()" style="width:200px; top:20px">
        <el-option 
          v-for="universityName in universityNameList"
          :key="universityName"
          :label="universityName"
          :value="universityName">
        </el-option>
      </el-select>
    </el-form>
    <el-form id="dept" style="position:relative; left:220px; top:-60px;">
      <el-select placeholder="학과선택" v-model="department_chosen" @change="showChange()" style="width:200px; top:20px;">
        <el-option 
          v-for="departmentName in departmentNameList"
          :key="departmentName"
          :label="departmentName"
          :value="departmentName">
        </el-option>
      </el-select>
    </el-form>
    </div>
    <master-bank-class
      :list="list"
      :sublist="sublist"
      :onClick="onClick"
    />
    <br/>
    <div class="right-align">
      <router-link to="/a/register/bank">
        <el-button  type="primary" :class="$attachReactablePostfix('right-align-btn')" style="width: 49%">
          <div class="right-align-btn-layer">세션은행 등록하기</div>
        </el-button>
      </router-link>
      <router-link to="/">
        <el-button type="primary" :class="$attachReactablePostfix('right-align-btn')" style="width: 49%">
          <div class="right-align-btn-layer">홈으로</div>
        </el-button>
      </router-link>
    </div>
  </div>
</template>

<script>
/* eslint-disable no-unused-vars */
import { mapActions, mapState } from 'vuex';
import MasterBankClass from '../partials/MasterBankClass';
import masterService from '../../services/masterService';
import utils from '../../utils';

export default {
  name: 'ViewBank',
  components: {
    MasterBankClass,
  },
  data() {
    return {
      userId: utils.getUserIdFromJwt(),
      searchType: 'name',
      searchText: '',
      list: [],
      sublist: [],
      universityNameList: [],
      departmentNameList: [],
      chosen: '',
      department_chosen: '',
    };
  },
  computed: {
    ...mapState('NNclass', ['studyingClassList']),
  },
  async created() {
    const vm = this;
  },
  async mounted() {
    const vm = this;
    const uniNameLists = await masterService.getUniNameLists();
    vm.universityNameList = uniNameLists.data.map(element => element.name);
  },
  watch: {
    list: async function list(val, oldVal) {
      const vm = this;
    },
  },
  methods: {
    ...mapActions('NNclass', [
      'getClassLists',
      'getMyClassLists',
      'deleteClassUser',
    ]),
    formatDate: utils.formatDate,
    async onClick(type, arg, arg2) {
      const vm = this;
      switch (type) {
        case 'DETAIL': {
          vm.$router.push(`/class/${arg.class_id}/classdetail`);
          break;
        }
        case 'LISTEN': {
          vm.$router.push(`/a/student/NNclass/${arg.class_id}`);
          break;
        }
        case 'CANCEL': {
          vm.$confirm(vm.$t('CONFIRM.WANT_RM_BNK'), `${''} ` + vm.$t('CONFIRM.DELETE_BNK'), {
            confirmButtonText: vm.$t('NOTE.CONFIRM'),
            cancelButtonText: vm.$t('NOTIFY.CANCEL'),
            type: 'warning',
          })
          .then(async () => {
            try {
              await vm.deleteClassUser({
                classId: arg.class_id,
                userId: vm.userId,
              });

              vm.$notify({
                title: vm.$t('NOTIFY.SUC_DEL_DEP'),
                message: vm.$t('NOTIFY.DEL_DEP'),
                type: 'success',
                duration: 3000,
              });
            } catch (error) {
              vm.$notify({
                title: vm.$t('NOTIFY.FAIL_DEL_DEP'),
                message: error.toString(),
                type: 'error',
                duration: 3000,
              });
            }

            try {
              await vm.getMyClassLists();
              vm.list.splice(arg2, 1);
            } catch (error) {
              vm.$notify({
                title: vm.$t('NOTIFY.FAIL_DEL_DEP'),
                message: error.toString(),
                type: 'error',
                duration: 0,
              });
            }
          })
          .catch(() => {
            vm.$notify({
              title: vm.$t('NOTIFY.INTERRUPTED'),
              message: vm.$t('NOTIFY.ABT_DEL_DEP'),
              type: 'info',
              duration: 3000,
            });
          });

          break;
        }
        case 'SEARCH': {
          vm.$router.push({ path: '/a/view/bank', query: { type: `${arg.searchType}`, text: `${arg.searchText}` } });
          break;
        }
        default: {
          throw new Error(`not defined type ${type}`);
        }
      }
    },
    onClickDelete(index) {
      const vm = this;
      const currentTeachingClass = vm.teachingClassList[index];
      vm.$confirm(vm.$t('NOTIFY.WANT_DLT_STUD'), `${currentTeachingClass.name || ''} ` + vm.$t('CONFIRM.DELETE'), {
        confirmButtonText: vm.$t('NOTE.CONFIRM'),
        cancelButtonText: vm.$t('NOTIFY.CANCEL'),
        type: 'warning',
      })
        .then(async () => {
          try {
            const currentClass = vm.teachingClassList[index];
            await masterService.delete({
              id: currentClass.class_id,
            });
            vm.deleteTeachingClass({
              teachingClassIndex: index,
            });
          } catch (error) {
            vm.$notify({
              title: vm.$t('NOTIFY.FAIL_DEL_STU'),
              message: error.toString(),
              type: 'error',
              duration: 3000,
            });
          }
        })
        .catch(() => {
          vm.$notify({
            title: vm.$t('NOTIFY.CANCELLED'),
            message: vm.$t('NOTIFY.CAN_DEL_STU'),
            type: 'info',
            duration: 3000,
          });
        });
    },
    async categoryChange() {
      const vm = this;
      const deptNameList = await masterService.getDeptLists({
        university_name: vm.chosen,
        category: undefined,
      });
      vm.departmentNameList = deptNameList.data.map(element => element.name);
      const res = await masterService.getBankLists({ university_name: vm.chosen });
      if (vm.chosen !== undefined && vm.department_chosen !== undefined) {
        vm.department_chosen = undefined;
      }
      for (let i = 0; i < res.data.length; i += 1) {
        if (res.data[i].user.department_name === null) {
          res.data[i].user.department_name = '소속없음';
        }
      }
      vm.list = res.data;
    },
    async showChange() {
      const vm = this;
      const res = await masterService.getBankLists({
        university_name: vm.chosen,
        department_name: vm.department_chosen,
      });
      for (let i = 0; i < res.data.length; i += 1) {
        if (res.data[i].user.department_name === null) {
          res.data[i].user.department_name = '소속없음';
        }
      }
      vm.list = res.data;
    },
  },
};
</script>


<style lang="scss" scoped>
#class_index_wrapper {
  z-index:1;
}

#class_index_wrapper {
  .page-title{
    float:left;
    width: 1000px;
    height: 24px;

    font-family: SpoqaHanSans;
    font-size: 25px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1.2;
    letter-spacing: normal;
    color: #000000;

    margin-top : 40px;
    margin-left : 12px;
    margin-bottom : 25px;

  }
  .el-form{
    font-family: SpoqaHanSans;
    font-size: 16px;
    font-weight: normal;
    font-style: normal;
    font-stretch: normal;
    line-height: 40px;
    letter-spacing: normal;
    color: #000000;
    width: 300px;
    margin: 20px 0 0 10px;
  }
}
</style>
